#pragma once

#include "XMLUtil.h"
#include "ScriptletContainerFactory.h"
#include "RootWindow.h"
#include "Application.h"

class NPCOMMONUI_API CWindowScriptletPlugin
{
public:
	CWindowScriptletPlugin();
	~CWindowScriptletPlugin(void);
	
	static CRootWindow* CreateBaseWindow(TiXmlElement* pNode, IDataContext* dataContext=NULL);
	static INT_PTR DoModalAgreement(TiXmlElement* pNode, HWND hWndParent, LPARAM lParam, IDataContext* dataContext, BOOL& bCoreValueChecked);
	static INT_PTR DoModal(TiXmlElement* pNode, HWND hWndParent=::GetActiveWindow(), LPARAM lParam=NULL, IDataContext* dataContext=NULL);
	static INT_PTR DoModal(CScriptletDialog* pDialog, TiXmlElement* pNode, HWND hWndParent=::GetActiveWindow(), LPARAM lParam=NULL, IDataContext* dataContext=NULL);
	static CScriptletDialog* CretateDialog( TiXmlElement* pNode );


	BOOL CreateBaseWindow(CRootWindow* pRootWindow, TiXmlElement* pNode);
	BOOL CreateBaseDialog(CRootWindow* pRootWindow, TiXmlElement* pNode);

protected:
	virtual LPCTSTR LoadString(LPCTSTR pszID) { return Application::LoadString(pszID); }

private:
	BOOL ModifyComponent(CRootWindow* pRootWindow, TiXmlElement* pNode);
	BOOL ParseChild(CRootWindow* pRootWindow, TiXmlElement* pNode);
};
